//=============================================
// Class Designer : Dip2K
// Coder : Dip2K
// Date : 2004/8
// Public Site : http://gisdeveloper.co.kr
//=============================================

#ifndef __DIP2K_OCI_INTERFACE_WRAPPER__
#define __DIP2K_OCI_INTERFACE_WRAPPER__ 

#include <oci.h>
#include <ocidem.h>
#include <iostream>
#include <vector>

using namespace std;

#define	 MAX_SELECT_LIST_SIZE   256		// Max Field Count
#define  MAX_ITEM_BUFFER_SIZE   1024	// Max Record Data Length
#define  MAX_FIELD_NAME_LENGTH	128		// Max Field Data Length


class COCIw {
private:
	typedef struct _cs_datafmt
	{
		sb4             maxlength;
		sb2             datatype;
		sb1             name[MAX_FIELD_NAME_LENGTH];
		sb4             namelen;
		sb4             dsize;
		sb2             precision;
		sb2             scale;
		sb2             status;
	} CS_DATAFMT;

	typedef struct _column_data 
	{
		ub1             *value;
		sb2             valuelen;
		ub2             col_retlen;
		ub2				col_retcode;
	} COLUMN_DATA;

public:

	COCIw();
	~COCIw();

	bool OpenDB(const char* service, const char* user, const char *pw);
	bool CloseDB();

	bool ExecuteDML(const char* SQL);
	bool Query(const char* SQL);

public:
	size_t GetRecordCount();
	size_t GetFieldCount();

	void GetRecordData(size_t row, size_t column, char* buf);

	void DisplayRecords();

private:
	void clearSet();

protected:
	vector<vector <string*> > rset_;
	vector<_cs_datafmt> flds_;

private:
	Lda_Def lda;
	Cda_Def cda;
	sword status;
	ub1 hda[HDA_SIZE];

	bool connected;
};

#endif